{% extends "base.html" %}
{% load static %}
{% load metadata_extras %}

{% block title %} Metadata details {% endblock %}
{% block titleHeader %} Metadata {% endblock %}
{% block titleSubHeader %}  {{ meta.checklist.name }} - {{ meta.checklist.database.name }}  {% endblock %}

{% block libraries %}

<script src="https://cdn.jsdelivr.net/npm/handsontable@8.3.2/dist/handsontable.full.min.js"></script>
<link href="https://cdn.jsdelivr.net/npm/handsontable@8.3.2/dist/handsontable.full.min.css"
      rel="stylesheet" media="screen">
{% endblock %}

{% block content %}
<div class="container-fluid">
    {% if message %}
    <p>
        <a href="{% url 'project_list' %}" class="btn btn-primary">
            <i class="fas fa-chevron-circle-left"></i> Project List
        </a>
    </p>
    <div class="alert alert-danger" role="alert">
        <p>{{ message }}</p>
        <p>Login In :<a class="alert-link" href="{% url 'login'%}">here</a>.
        </p>
    </div>
    {% else %}
    <p>
        <a href="{% url 'project_detail' id_project=meta.project.id %}"
           class="btn btn-primary">
            <i class="fas fa-chevron-circle-left"></i> Back to project
        </a>
        <button class="btn btn-primary" type="button" data-bs-toggle="collapse"
                data-bs-target="#moreProject" aria-expanded="false"
                aria-controls="moreProject">
            <i class="fas fa-plus"></i> Project resume
        </button>

        <button class="btn btn-primary" type="button" data-bs-toggle="collapse"
                data-bs-target="#moreMetadata" aria-expanded="false"
                aria-controls="moreMetadata">
            <i class="fas fa-plus"></i> Metadata resume
        </button>

        <button class="btn btn-primary" type="button" data-bs-toggle="collapse"
                data-bs-target="#loadMetadata" aria-expanded="false"
                aria-controls="loadMetadata">
            <i class="fas fa-cloud-download-alt"></i> Import metadata
        </button>

        {% if instruction %}
        <button class="btn btn-primary" type="button" data-bs-toggle="collapse"
                data-bs-target="#instructionMetadata" aria-expanded="false"
                aria-controls="instructionMetadata">
            <i class="fas fa-info-circle"></i> Instructions
        </button>
        {% endif %}
    </p>

    <div class="collapse" id="moreProject">
        <div class="card-header">
            <b>Project resume</b>
        </div>
        <div class="card card-body">
            <p><b>Name</b></p>
            <p>{{ meta.project.title }}</p>
            <p><b>Description</b></p>
            <p>{{ meta.project.description }}</p>
        </div>
    </div>

    <div class="collapse" id="moreMetadata">
        <div class="card-header">
            <b>More information about metadata</b>
        </div>
        <div class="card card-body">
            <p><b>Created :</b> : {{ meta.created_date }} by {{ meta.created_by }}</p>
            <p><b>Last modification :</b> : {{ meta.last_modification_date }} by  {{ meta.last_modification_by }} </p>
            <p><b>Short description :</b> : {{ meta.short_description }} </p>
        </div>
    </div>

    <div class="collapse" id="loadMetadata">
        <div class="card-header">
            <b>Import metadata</b>
        </div>
        <div class="card card-body">
            <p><b>From EMERGEN-DB</b></p>
            <div class="row mb-3">
                <label for="token_EMERGEN" class="col-auto col-form-label">Your
                    token</label>
                <div class="col-auto">
                    <input type="password" id="token_EMERGEN"
                           name="token_EMERGEN" class="form-control">
                </div>
                <div class="col-auto">
                    <button type="button" class="btn btn-primary"
                            id='load_metadata'>
                        <i class="fas fa-info-circle"></i> Load from
                        EMERGEN-DB
                    </button>
                </div>
            </div>
        </div>
    </div>

    {% if instruction %}
    <div class="collapse" id="instructionMetadata">
        <div class="card-header">
           <b>Instructions</b>
        </div>
        <div class="card card-body">
                {{ instruction|linebreaks }}
        </div>
    </div>
    {% endif %}

    <div class="row">
        <div class="col-8">
            <h2>Metadata table</h2>
            <button type="button" class="btn btn-success" id='save_metadata'>
                <i class="fas fa-save"></i> Save
            </button>
            <button id="export-file_csv" class="btn btn-primary"><i class="fas fa-download"></i> Download CSV</button>
            <button id="export-file_tsv" class="btn btn-primary"><i class="fas fa-download"></i> Download TSV</button>

            <br><br>
            <div id="handsontable_metadata"
                 class="hot handsontable htRowHeaders htColumnHeaders"
                 style="height: 500px; overflow: hidden; width: 100%;"
                 data-originalstyle="height: 500px; overflow: hidden; width: 100%;"></div>
        </div>
        <div class="col-4">
            <h2>Description</h2>

            <div id="scrollDiv" style="height:700px; overflow:auto; position:relative;">
                <div class="accordion accordion-flush" id="accordionFields">
                    {% for field in fields %}
                    <div class="accordion-item">
                        <h2 class="accordion-header"
                            id="heading_{{ field.name|remove_punct }}">
                            <button class="accordion-button collapsed"
                                    id="btn_{{ field.name|remove_punct }}"
                                    type="button" data-bs-toggle="collapse"
                                    data-bs-target="#collapse_{{ field.name|remove_punct }}"
                                    aria-expanded="false"
                                    aria-controls="collapse_{{ field.name|remove_punct }}">
                                {{ field.name|capfirst }}
                            </button>
                        </h2>
                        <div id="collapse_{{ field.name|remove_punct }}"
                             class="accordion-collapse collapse"
                             aria-labelledby="heading_{{ field.name|remove_punct }}"
                             data-bs-parent="#accordionFields"
                        >
                            <div class="accordion-body">
                                <p><b>Description</b></p>
                                <p>{{ field.description|capfirst }}</p>

                                <p><b>Format</b></p>
                                <p>{{ field.format }}</p>

                                <p><b>Restriction</b></p>
                                <p>{{ field.restriction|remove_alpha }}</p>

                                <p><b>Examples</b></p>
                                <p>{{ field.example }}</p>

                                <p class="required">{% if field.requirement == "mandatory" %} <span style="color: red;"><i class="fa fa-asterisk"></i></span> {% endif %} {{ field.requirement }}</p>
                            </div>
                        </div>
                    </div>
                    {% endfor %}
                </div>
            </div>

        </div>
    </div>


    <script>

        /* ####################################################################

        HANDSONTABLE

        #################################################################### */

        var None = null;
        var False = false;
        var True = true;
        var save = document.getElementById('save_metadata');
        var load = document.getElementById('load_metadata');
        var container = document.getElementById('handsontable_metadata');

        var hot = new Handsontable(container, {
          {% if meta.table %} data:  {{ meta.table | safe }}, {% endif %}
          width: '100%',
          rowHeaders: true,
          colHeaders: {% if meta.table %} Object.keys({{ meta.table | safe }} [0]) {% else %}  true {% endif %},
          filters: true,
          contextMenu: true,
          dropdownMenu: true,
          autoColumnSize: true,
          comments: true,
          contextMenu: {
                        items: {
                          "row_above": {
                            name: 'Click to add row above',
                            disabled: function () { // `disabled` can be a boolean or a function
                                                      // Disable option when first row was clicked
                                                      return this.getSelectedLast()[0] === 0;
                                                    }
                          },
                          "row_below": {
                            name: 'Click to add row below'
                          },
                          "clear_column" : {
                            name: 'Clear column'
                          },
                          "remove_row": {
                            name: 'Remove row(s)'
                          },
                          "sp1": '---------',
                          "not_app": {
                            name: "not applicable",
                            callback: function(key, selection, clickEvent) {
                              var selected = this.getSelected();
		                      this.setDataAtCell(selected[0][0], selected[0][1], 'not applicable');
                            }
                          },
                          "not_col": {
                            name: "not collected",
                            callback: function(key, selection, clickEvent) {
                              var selected = this.getSelected();
		                      this.setDataAtCell(selected[0][0], selected[0][1], 'not collected');
                            }
                          },
                          "not_prov": {
                            name: "not provided",
                            callback: function(key, selection, clickEvent) {
                              var selected = this.getSelected();
		                      this.setDataAtCell(selected[0][0], selected[0][1], 'not provided');
                            }
                          },
                          "unknown": {
                            name: "unknown",
                            callback: function(key, selection, clickEvent) {
                              var selected = this.getSelected();
		                      this.setDataAtCell(selected[0][0], selected[0][1], 'unknown');
                            }
                          },

                          "sp2": '---------',
                          "colors": {
                            name: 'Colors...',
                            submenu: {
                              // Custom option with submenu of items
                              items: [
                                {
                                  // Key must be in the form "parent_key:child_key"
                                  key: 'colors:Red',
                                  name: 'Red',
                                  callback: function(key, selection, clickEvent) {
                                    var selected = this.getSelected();
                                    this.getCell(selected[0][0], selected[0][1]).style.backgroundColor = '#ffdbdb';
                                    this.setCellMeta(selected[0][0], selected[0][1], 'backgroundColor', '#ffdbdb');
                                  }
                                },
                                { key: 'colors:Yellow', name: 'Yellow',
                                    callback: function(key, selection, clickEvent) {
                                        var selected = this.getSelected();
                                        this.getCell(selected[0][0], selected[0][1]).style.backgroundColor = '#fff5db';
                                        this.setCellMeta(selected[0][0], selected[0][1], 'backgroundColor', '#fff5db');
                                    }
                                 },
                                 { key: 'colors:Green', name: 'Green',
                                    callback: function(key, selection, clickEvent) {
                                        var selected = this.getSelected();
                                        this.getCell(selected[0][0], selected[0][1]).style.backgroundColor = '#e4ffde';
                                        this.setCellMeta(selected[0][0], selected[0][1], 'backgroundColor', '#e4ffde');
                                    }
                                 },
                                 { key: 'colors:None', name: 'None',
                                    callback: function(key, selection, clickEvent) {
                                        var selected = this.getSelected();
                                        this.getCell(selected[0][0], selected[0][1]).style.backgroundColor = "";
                                        this.removeCellMeta(selected[0][0], selected[0][1], 'backgroundColor');
                                    }
                                 }

                              ]
                            }
                          },
                          "Format": {
                            name: 'Format...',
                            submenu: {
                              items: [
                                {
                                  key: 'Format:bold',
                                  name: 'bold',
                                  callback: function(key, selection, clickEvent) {
                                    var selected = this.getSelected();
                                    this.getCell(selected[0][0], selected[0][1]).style.fontWeight = 'bold';
                                    this.setCellMeta(selected[0][0], selected[0][1], 'fontWeight', 'bold');
                                  }
                                },
                                {
                                  key: 'Format:italic',
                                  name: 'italic',
                                  callback: function(key, selection, clickEvent) {
                                    var selected = this.getSelected();
                                    this.getCell(selected[0][0], selected[0][1]).style.fontStyle = 'italic';
                                    this.setCellMeta(selected[0][0], selected[0][1], 'fontStyle', 'italic');
                                  }
                                },
                              ]
                            }
                          },
                          "remove_style": {
                            name: "Clear style",
                            callback: function(key, selection, clickEvent) {
                              var selected = this.getSelected();
                              this.getCell(selected[0][0], selected[0][1]).removeAttribute("style");
                              this.removeCellMeta(selected[0][0], selected[0][1], 'fontStyle');
                              this.removeCellMeta(selected[0][0], selected[0][1], 'fontWeight');
                              this.removeCellMeta(selected[0][0], selected[0][1], 'backgroundColor');
                            }
                          },
                        }
                      },

          licenseKey: 'non-commercial-and-evaluation',
          afterChange: function (change, source) {
            save.classList.add('btn-warning');
            save.classList.remove('btn-success');
          }

        });

        {% if meta.metadata %}
        var met = {{  meta.metadata|safe }}
        var plugin = hot.getPlugin('Comments');

        met.forEach(function(item){
            if ( typeof item.backgroundColor !== 'undefined' ){
                hot.getCell(item.row, item.col).style.backgroundColor = item.backgroundColor;
                hot.setCellMeta(item.row, item.col, 'backgroundColor', item.backgroundColor );
            }

            if ( typeof item.fontStyle !== 'undefined' ){
                hot.getCell(item.row, item.col).style.fontStyle = item.fontStyle;
                hot.setCellMeta(item.row, item.col, 'fontStyle', item.fontStyle );
            }

            if ( typeof item.fontWeight !== 'undefined' ){
                hot.getCell(item.row, item.col).style.fontWeight = item.fontWeight;
                hot.setCellMeta(item.row, item.col, 'fontWeight', item.fontWeight );
            }
        });
        {% endif %}

        hot.addHook('afterSelectionEnd', function(r, c, r2, c2) {

            if(c == c2){
                var list = document.getElementsByClassName('accordion-collapse');
                for (let item of list) {
                    if (item.classList.contains('show')) {
                      item.classList.remove('show');
                    }
                }

                var list = document.getElementsByClassName('accordion-button');
                for (let item of list) {
                    if (! item.classList.contains('collapsed')) {
                      item.classList.add('collapsed');
                    }
                }

                var create_id = hot.getColHeader(c).replace(/[.,\/#!$%\^&\*;:{}=\-_`~()]/g,"").replace(/\s/g, '');

                var element = document.getElementById("collapse_" + create_id);
                element.classList.add("show");

                var element = document.getElementById("btn_" + create_id);
                element.classList.remove("collapsed");

                var element = document.getElementById('heading_'+ create_id);
                var topPos = element.offsetTop;

                document.getElementById('scrollDiv').scroll({
                  top: topPos - 5,
                  left: 0,
                  behavior: 'smooth'
                });
            }
        });

        var button_csv = document.getElementById('export-file_csv');
        var button_tsv = document.getElementById('export-file_tsv');
        var exportPlugin = hot.getPlugin('exportFile');

        button_csv.addEventListener('click', function() {
            exportPlugin.downloadFile('csv', {
              bom: false,
              columnDelimiter: ',',
              columnHeaders: true,
              exportHiddenColumns: true,
              exportHiddenRows: true,
              fileExtension: 'csv',
              filename: 'omicsBroker-CSV-file_[YYYY]-[MM]-[DD]',
              mimeType: 'text/csv',
              rowDelimiter: '\r\n',
              rowHeaders: true
            });
        });

        button_tsv.addEventListener('click', function() {
            exportPlugin.downloadFile('csv', {
              bom: false,
              columnDelimiter: '\t',
              columnHeaders: true,
              exportHiddenColumns: true,
              exportHiddenRows: true,
              fileExtension: 'tsv',
              filename: 'omicsBroker-TSV-file_[YYYY]-[MM]-[DD]',
              mimeType: 'text/tsv',
              rowDelimiter: '\r\n',
              rowHeaders: true
            });
        });

        function allComments(element){
              comments.push(element.comment);
        }

        Handsontable.dom.addEvent(save, 'click', function() {

            var jsonArr = [];

            hot.getCellsMeta().forEach(function(item){

                var o = new Object();
                o.row = item.row;
                o.col= item.col;

                if (typeof item.backgroundColor !== 'undefined') {
                        o.backgroundColor = item.backgroundColor
                }

                if (typeof item.fontStyle !== 'undefined') {
                        o.fontStyle = item.fontStyle
                }

                if (typeof item.fontWeight !== 'undefined') {
                        o.fontWeight = item.fontWeight
                }

                if(Object.keys(o).length != 2) {
                    jsonArr.push(o);
                }
            } );

            console.log(jsonArr);

            $.ajax({
                type: "POST",
                contentType: "application/json",
                url : "{% url 'save_metadata' id_meta=meta.id %}",
                 headers:{
                    "X-CSRFToken": '{{ csrf_token }}'
                 },
                data : JSON.stringify({data: hot.getSourceData(), metadata: jsonArr }),
                dataType: "json"
            });

            save.classList.add('btn-success');
            save.classList.remove('btn-warning');
        });


        Handsontable.dom.addEvent(load, 'click', function() {
              var token = document.getElementById('token_EMERGEN').value;

              if(token == ""){
              alert("Add a toker");
              }

              $.ajax({
                   type: 'GET',
                   url: 'https://emergen-db.france-bioinformatique.fr/api/results/',
                   contentType: "application/json",
                   headers: {"Authorization": 'Token ' + token },
                   success: function(res){
                        hot.loadData(res);
                        hot.updateSettings({
                          colHeaders: Object.keys(res[0])
                        });
                        console.log('Data loaded');
                   },
                   error: function(error) {
                        console.log('Error!',error)
                   }
               })
        });

    </script>
    {% endif %}

</div>
{% endblock %}